//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "HowToUse_.h"
#include "MediaInfoDLL.h"
#include <string>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Left=(Screen->Width-Width)/2;
    Top=(Screen->Height-Height)/2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	//Information about MediaInfo
    WideString To_Display=MediaInfo_Option(NULL, L"Info_Version", L""); //Note : I would have liked to use std::wstring, but I have a big bug with it (+= operator doesn't suprress '\0' if used with MediaInfo methods)

    To_Display += L"\r\n\r\nInfo_Parameters\r\n";
    To_Display += MediaInfo_Option(NULL, L"Info_Parameters", L"");

    To_Display += L"\r\n\r\nInfo_Capacities\r\n";
    To_Display += MediaInfo_Option(NULL, L"Info_Capacities", L"");

    To_Display += L"\r\n\r\nInfo_Codecs\r\n";
    To_Display += MediaInfo_Option(NULL, L"Info_Codecs", L"");

	//An example of how to use the library
    To_Display += L"\r\n\r\nOpen\r\nHandle=";
    void* Handle = MediaInfo_Open(L"C:\\Example.ogg");
    To_Display += WideString((int)Handle);

    To_Display += L"\r\n\r\nInform with Complete=false\r\n";
    MediaInfo_Option(Handle, L"Complete", L"");
    To_Display += MediaInfo_Inform(Handle, InformOption_Nothing);

    To_Display += L"\r\n\r\nInform with Complete=true\r\n";
    MediaInfo_Option(Handle, L"Complete", L"1");
    To_Display += MediaInfo_Inform(Handle, InformOption_Nothing);

    To_Display += L"\r\n\r\nCustom Inform\r\n";
    MediaInfo_Option(Handle, L"Inform", L"General;Example : FileSize=%FileSize%");
    To_Display += MediaInfo_Inform(Handle, InformOption_Custom);

    To_Display += L"\r\n\r\nGetI with Stream=General and Parameter=13\r\n";
    To_Display += MediaInfo_GetI(Handle, Stream_General, 0, 13, Info_Text);

    To_Display += L"\r\n\r\nCount_Get with StreamKind=Stream_Audio\r\n";
    To_Display += WideString(MediaInfo_Count_Get(Handle, Stream_Audio, -1));

    To_Display += L"\r\n\r\nGet with Stream=General and Parameter=\"AudioCount\"\r\n";
    To_Display += MediaInfo_Get(Handle, Stream_General, 0, L"AudioCount", Info_Text, Info_Name);

    To_Display += L"\r\n\r\nGet with Stream=Audio and Parameter=\"StreamCount\"\r\n";
    To_Display += MediaInfo_Get(Handle, Stream_Audio, 0, L"StreamCount", Info_Text, Info_Name);

    To_Display += L"\r\n\r\nGet with Stream=General and Parameter=\"FileSize\"\r\n";
    To_Display += MediaInfo_Get(Handle, Stream_General, 0, L"FileSize", Info_Text, Info_Name);

    To_Display += L"\r\n\r\nClose\r\n";
    MediaInfo_Close(Handle);

    //Displaying the text
    Memo1->Text = To_Display;
}
//---------------------------------------------------------------------------
