Public Class HowToUse_Dll
    Inherits System.Windows.Forms.Form

#Region " Code gnr par le Concepteur Windows Form "

    Public Sub New()
        MyBase.New()

        'Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()

        'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()

    End Sub

    'La mthode substitue Dispose du formulaire pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    Friend WithEvents RichTextBox1 As System.Windows.Forms.RichTextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.RichTextBox1 = New System.Windows.Forms.RichTextBox()
        Me.SuspendLayout()
        '
        'RichTextBox1
        '
        Me.RichTextBox1.Location = New System.Drawing.Point(8, 8)
        Me.RichTextBox1.Name = "RichTextBox1"
        Me.RichTextBox1.Size = New System.Drawing.Size(760, 504)
        Me.RichTextBox1.TabIndex = 0
        Me.RichTextBox1.Text = ""
        '
        'HowToUse_Dll
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(776, 516)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.RichTextBox1})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.Name = "HowToUse_Dll"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MediaIfno.Dll Example"
        Me.ResumeLayout(False)

    End Sub

#End Region
    'YOU MUST DO : Put MediaInfo.Dll and Example.ogg in the "./Bin/Configuration name" folder
    'WARNING : Use GetString Method for converting wchar* to Unicode String
    Private Declare Unicode Function lstrlenW Lib "kernel32" (ByVal Ptr As Integer) As Integer
    Private Declare Unicode Function lstrcpyW Lib "kernel32" (ByVal RetVal As String, ByVal Ptr As Integer) As Integer
    Private Declare Unicode Function MediaInfo_Open Lib "MediaInfo.DLL" (ByVal File As String) As Integer
    Private Declare Unicode Function MediaInfo_Close Lib "MediaInfo.DLL" (ByVal Handle As Integer) As Integer
    Private Declare Unicode Function MediaInfo_Inform Lib "MediaInfo.DLL" (ByVal Handle As Integer, ByVal Options As Integer) As Integer 'WARNING : This is a wchar* value
    Private Declare Unicode Function MediaInfo_GetI Lib "MediaInfo.DLL" (ByVal Handle As Integer, ByVal StreamKind As Integer, ByVal StreamNumber As Integer, ByVal Parameter As Integer, ByVal KindOfInfo As Integer) As Integer 'WARNING : This is a wchar* value, see MediaInfoDLL.h for enumeration values
    Private Declare Unicode Function MediaInfo_Get Lib "MediaInfo.DLL" (ByVal Handle As Integer, ByVal StreamKind As Integer, ByVal StreamNumber As Integer, ByVal Parameter As String, ByVal KindOfInfo As Integer, ByVal KindOfSearch As String) As Integer 'WARNING : This is a wchar* value, see MediaInfoDLL.h for enumeration values
    Private Declare Unicode Function MediaInfo_Option Lib "MediaInfo.DLL" (ByVal Handle As Integer, ByVal Optionn As String, ByVal Value As String) As Integer 'WARNING : This is a wchar* value
    Private Declare Unicode Function MediaInfo_State_Get Lib "MediaInfo.DLL" (ByVal Handle As Integer) As Integer 'see MediaInfo.h for details
    Private Declare Unicode Function MediaInfo_Count_Get Lib "MediaInfo.DLL" (ByVal Handle As Integer, ByVal StreamKind As Integer, ByVal StreamNumber As Integer) As Integer 'see MediaInfoDLL.h for enumeration values

    Public Function GetString(ByVal lpszW As Integer) As String
        GetString = New String(ChrW(0), lstrlenW(lpszW))
        Call lstrcpyW(GetString, lpszW)
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Handle As Object
        Dim To_Display As String
        Dim Temp As String

        'Information about MediaInfo
        To_Display = GetString(MediaInfo_Option(0, "Info_Version", ""))

        To_Display += vbCrLf + vbCrLf + "Info_Parameters" + vbCrLf
        To_Display += GetString(MediaInfo_Option(0, "Info_Parameters", ""))

        To_Display += vbCrLf + vbCrLf + "Info_Capacities" + vbCrLf
        To_Display += GetString(MediaInfo_Option(0, "Info_Capacities", ""))

        To_Display += vbCrLf + vbCrLf + "Info_Codecs" + vbCrLf
        To_Display += GetString(MediaInfo_Option(0, "Info_Codecs", ""))

        'An example of how to use the library
        RichTextBox1.Text = RichTextBox1.Text + vbCrLf + vbCrLf + "Open" + vbCrLf
        Handle = MediaInfo_Open("Example.ogg")

        To_Display += vbCrLf + vbCrLf + "Inform with Complete=false" + vbCrLf
        MediaInfo_Option(Handle, "Complete", "")
        To_Display += GetString(MediaInfo_Inform(Handle, 0))

        To_Display += vbCrLf + vbCrLf + "Inform with Complete=true" + vbCrLf
        MediaInfo_Option(Handle, "Complete", "1")
        To_Display += GetString(MediaInfo_Inform(Handle, 0))

        To_Display += vbCrLf + vbCrLf + "Custom Inform" + vbCrLf
        MediaInfo_Option(Handle, "Inform", "General;Example : FileSize=%FileSize%")
        To_Display += GetString(MediaInfo_Inform(Handle, 1))

        To_Display += vbCrLf + vbCrLf + "Get with Stream=General and Parameter='FileSize'" + vbCrLf
        To_Display += GetString(MediaInfo_Get(Handle, 0, 0, "FileSize", 1, 0))

        To_Display += vbCrLf + vbCrLf + "GetI with Stream=General and Parameter=13" + vbCrLf
        To_Display += GetString(MediaInfo_GetI(Handle, 0, 0, 13, 1))

        To_Display += vbCrLf + vbCrLf + "Count_Get with StreamKind=Stream_Audio" + vbCrLf
        Temp = MediaInfo_Count_Get(Handle, 2, -1)
        To_Display += Temp

        To_Display += vbCrLf + vbCrLf + "Get with Stream=General and Parameter='AudioCount'" + vbCrLf
        To_Display += GetString(MediaInfo_Get(Handle, 0, 0, "AudioCount", 1, 0))

        To_Display += vbCrLf + vbCrLf + "Get with Stream=Audio and Parameter='StreamCount'" + vbCrLf
        To_Display += GetString(MediaInfo_Get(Handle, 2, 0, "StreamCount", 1, 0))

        To_Display += RichTextBox1.Text + vbCrLf + vbCrLf + "Close" + vbCrLf
        MediaInfo_Close(Handle)

        'Displaying the text
        RichTextBox1.Text = To_Display
    End Sub

    Private Sub RichTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RichTextBox1.TextChanged

    End Sub
End Class
